There are n people standing in a circle waiting to be executed. The counting out begins at some point in the circle and proceeds around the circle in a fixed direction. In each step, a certain number of people are skipped and the next person is executed. The elimination proceeds around the circle (which is becoming smaller and smaller as the executed people are removed), until only the last person remains, who is given freedom. Given the total number of persons n and a number k which indicates that k-1 persons are skipped and kth person is killed in circle. The task is to choose the place in the initial circle so that you are the last one remaining and so survive.
We have discussed a generalized solution in below set 1.
Josephus problem | Set 1 (A O(n) Solution)
In this post, a special case is discussed when k = 2
Examples :
Input : n = 5 Output : The person at position 3 survives Explanation : Firstly, the person at position 2 is killed, then at 4, then at 1 is killed. Finally, the person at position 5 is killed. So the person at position 3 survives. Input : n = 14 Output : The person at position 13 survives
Below are some interesting facts.
- In first round all even positioned persons are killed.
- For second round two cases arise
- If n is even : For example n = 8. In first round, first 2 is killed, then 4, then 6, then 8. In second round, we have 1, 3, 5 and 7 in positions 1st, 2nd, 3rd and 4th respectively.
- If n is odd : For example n = 7. In first round, first 2 is killed, then 4, then 6. In second round, we have 3, 5, 7 in positions 1st, 2nd and 3rd respectively.
If n is even and a person is in position x in current round, then the person was in position 2x – 1 in previous round.
If n is odd and a person is in position x in current round, then the person was in position 2x + 1 in previous round.
From above facts, we can recursively define the formula for finding position of survivor.
Let f(n) be position of survivor for input n, the value of f(n) can be recursively written as below. If n is even f(n) = 2f(n/2) - 1 Else f(n) = 2f((n-1)/2) + 1
Solution of above recurrence is
f(n) = 2(n - 2^{floor(Log2n)} + 1 = 2n - 2^{1 + floor(Log2n)} + 1
Below is the implementation to find value of above formula.
C++
// C/C++ program to find solution of Josephus // problem when size of step is 2. #include <stdio.h> // Returns position of survivor among a circle // of n persons and every second person being // killed int josephus( int n) { // Find value of 2 ^ (1 + floor(Log n)) // which is a power of 2 whose value // is just above n. int p = 1; while (p <= n) p *= 2; // Return 2n - 2^(1+floor(Logn)) + 1 return (2 * n) - p + 1; } // Driver Program to test above function int main() { int n = 16; printf ( "The chosen place is %d" , josephus(n)); return 0; } |
Java
// Java program to find solution of Josephus // problem when size of step is 2. import java.io.*; class GFG { // Returns position of survivor among // a circle of n persons and every // second person being killed static int josephus( int n) { // Find value of 2 ^ (1 + floor(Log n)) // which is a power of 2 whose value // is just above n. int p = 1 ; while (p <= n) p *= 2 ; // Return 2n - 2^(1+floor(Logn)) + 1 return ( 2 * n) - p + 1 ; } // Driver Program to test above function public static void main(String[] args) { int n = 16 ; System.out.println( "The chosen place is " + josephus(n)); } } // This Code is Contributed by Anuj_67 |
Python3
# Python3 program to find solution of # Josephus problem when size of step is 2. # Returns position of survivor among a # circle of n persons and every second # person being killed def josephus(n): # Find value of 2 ^ (1 + floor(Log n)) # which is a power of 2 whose value # is just above n. p = 1 while p < = n: p * = 2 # Return 2n - 2^(1 + floor(Logn)) + 1 return ( 2 * n) - p + 1 # Driver Code n = 16 print ( "The chosen place is" , josephus(n)) # This code is contributed by Shreyanshi Arun. |
C#
// C# program to find solution of Josephus // problem when size of step is 2. using System; class GFG { // Returns position of survivor among // a circle of n persons and every // second person being killed static int josephus( int n) { // Find value of 2 ^ (1 + floor(Log n)) // which is a power of 2 whose value // is just above n. int p = 1; while (p <= n) p *= 2; // Return 2n - 2^(1+floor(Logn)) + 1 return (2 * n) - p + 1; } // Driver Program to test above function static void Main() { int n = 16; Console.Write( "The chosen place is " + josephus(n)); } } // This Code is Contributed by Anuj_67 |
PHP
<?php // PHP program to find solution // of Josephus problem when // size of step is 2. // Returns position of survivor // among a circle of n persons // and every second person being // killed function josephus( $n ) { // Find value of 2 ^ (1 + floor(Log n)) // which is a power of 2 whose value // is just above n. $p = 1; while ( $p <= $n ) $p *= 2; // Return 2n - 2^(1+floor(Logn)) + 1 return (2 * $n ) - $p + 1; } // Driver Code $n = 16; echo "The chosen place is " , josephus( $n ); // This code is contributed by ajit. ?> |
The chosen place is 1
Output :
The chosen place is 1
Time complexity of above solution is O(Log n).
This article is contributed by Rahul Jain.
An another interesting solution to the problem while k=2 can be given based on an observation, that we just have to left rotate the binary representation of N to get the required answer. A working code for
the same is provided below considering number to be 64-bit number.
Below is the implementation of the above approach:
// C++ program to find solution of Josephus // problem when size of step is 2. #include <bits/stdc++.h> using namespace std; // Returns position of survivor among a circle // of n persons and every second person being // killed int josephus( int n) { // An interesting observation is that // for every number of power of two // answer is 1 always. if (!(n & (n - 1)) && n) { return 1; } // The trick is just to right rotate the // binary representation of n once. // Find whether the number shed off // during left shift is set or not bitset<64> Arr(n); // shifting the bitset Arr // f will become true once leftmost // set bit is found bool f = false ; for ( int i = 63; i >= 0; --i) { if (Arr[i] == 1 && !f) { f = true ; Arr[i] = Arr[i - 1]; } if (f) { // shifting bits Arr[i] = Arr[i - 1]; } } Arr[0] = 1; int res; // changing bitset to int res = ( int )(Arr.to_ulong()); return res; } // Driver Program to test above function int main() { int n = 16; printf ( "The chosen place is %d" , josephus(n)); return 0; } |
The chosen place is 1
Time Complexity : O(log(n))
This idea is contributed by Anukul Chand.
If you like GeeksforGeeks and would like to contribute, you can also write an article using contribute.geeksforgeeks.org or mail your article to contribute@geeksforgeeks.org. See your article appearing on the GeeksforGeeks main page and help other Geeks.
Please write comments if you find anything incorrect, or you want to share more information about the topic discussed above.
Attention reader! Don’t stop learning now. Get hold of all the important DSA concepts with the DSA Self Paced Course at a student-friendly price and become industry ready.
Recommended Posts:
- Prim's Algorithm (Simple Implementation for Adjacency Matrix Representation)
- Find if a degree sequence can form a simple graph | Havel-Hakimi Algorithm
- Shortest Superstring Problem | Set 2 (Using Set Cover)
- Word Break Problem | DP-32 | Set - 2
- Exact Cover Problem and Algorithm X | Set 1
- Exact Cover Problem and Algorithm X | Set 2 (Implementation with DLX)
- The Skyline Problem | Set 2
- Maths behind number of paths in matrix problem
- Program to solve the Alligation Problem
- Travelling Salesman Problem implementation using BackTracking
- Twisted Tower of Hanoi Problem
- Widest Path Problem | Practical application of Dijkstra's Algorithm
- Traveling Salesman Problem using Genetic Algorithm
- Dividing Sticks Problem
- 0/1 Knapsack Problem to print all possible solutions
- Difference between NP hard and NP complete problem
- Understanding threads on Producer Consumer Problem | Java
- Proof that Subgraph Isomorphism problem is NP-Complete
- Proof that Clique Decision problem is NP-Complete
- Travelling Salesman Problem | Greedy Approach